﻿
function setup_gps()
{
  $(".gps").each(function(){
    var center = $(this).attr("data_avg");
    var track = $(this).attr("data_track");
    var rect = $(this).attr("data_min") + "," + $(".gps").attr("data_max");

    if (!track)
    {
      track="ll="+center+"&z=8";
    }else{
      track="pl="+track;
    }

    $(this)
      .hide()
      .html($('#t_map').html().replace('{{center}}', center).replace('{{track}}', track));

    $(this).parents(".node").find(".buttons").append("<button class='btn btn-xs btn-default showgps' href='#'></button>");

  });

  $(".showgps")
  .text(t_track)
  .click(function(){
    var that = $(this).parents(".node").find(".gps")[0];
    if (that.style.display == "none" ){
      $(that).fadeIn();
    }else{
      $(that).fadeOut();
    }
    return false;
  });

  $(".mapclose")
  .click(function(){
    var that = $(this).parents(".node").find(".showgps")[0];
    $(that).click();
    return false;
  })

  $(".minorclose")
  .click(function(){
    var that = $(this).parents(".node").find(".showmore")[0];
    $(that).click();
    return false;
  })

}

$(function(){

  $(".head").append("<div class='buttons'/>");
  $(".buttons").append("<button class='btn btn-xs btn-default showmore' href='#'></a>");

  $(".minor").hide();

  $(".showmore")
  .text(t_showmore)
  .click(function(){
    var that = $(this).parents(".node").find(".minor")[0];
    if (that.style.display == "none" ){
      $(that).fadeIn();
      $(this).text(t_showless);
    }else{
      $(that).fadeOut();
      $(this).text(t_showmore);
    }
    return false;
  });

  setup_gps();

  $("#allmaps").click(function(){
    $(".showgps").click();
  });

  $("#allminor").click(function(){
    $(".showmore").click();
  });

  $(".sname").each(function(){
     var sid = $(this).attr("sid");
     $(this).before("<span class='chartbutton' sid='"+sid+"'>&#8776;</span>");
  });
  $(".chartbutton").click(function(){
    var sid = $(this).next(".sname").attr("sid")
    
    $(".chartbutton[sid='"+sid+"']").toggleClass('active');

    toggle_chart(sid);
  });

  place_canvas($(".node")[0]);

  $( window ).resize(function() {
    $("#rrc").remove();
    place_canvas($(".node")[0]);
  });

});

var ccolors = ['#8dd3c7','#efefb3','#bebada','#fb8072','#80b1d3','#fdb462','#b3de69','#fccde5','#d9d9d9','#bc80bd']

function place_canvas(element)
{
  $(element).before("<div id='rrc'><div id='rchart'></div></div>");

  var rcleft = $(".major").first().width();

  var width = $("#content").width() - $(".major").first().width();

  RootPaper = Raphael("rchart", width, $("#content").height());

  $("#rchart").css("left", rcleft);
}

var charts = {};

function toggle_chart(sid)
{
  console.log(sid);
  if (charts[sid] == null) {
    var c = draw_chart(sid);
    charts[sid] = c;
  } else {
    var c = charts[sid];
    c.remove();
    charts[sid] = null;
  }
}

function draw_chart(sid)
{
  var nodes = $(".node span.sname[sid='"+sid+"']");

  var node_idx = $(".node").first().find("span.sname").index(nodes[0])
  console.log(node_idx);

  var nodes_v = nodes.toArray().map(function(n){
    return $(n).next("span[svalue]");
  });

  var float_v = nodes_v.map(function(n){
    return parseFloat(n[0].getAttribute("svalue").replace(",", "."));
  });
  for(var i = 0; i < float_v.length; i++)
  {
    if (Number.isNaN(float_v[i]) && i > 0)
      float_v[i] = float_v[i-1];
  }
  var max_v = Math.max.apply(null, float_v);
  var min_v = Math.min.apply(null, float_v);

  //alert(max_v + " "+ min_v);
  var path = "";
  var fix_voffset = $("#rrc").offset().top;
  var width = RootPaper.width - 5;

  nodes.each(function(i, n){
    var cv = float_v[i];
    var y = $(n).offset().top - fix_voffset;
    var x = 5+ (cv - min_v) / (max_v - min_v) * width;
    if (path.length == 0)
      path += "M";
    else
      path += "L";
    path += Math.round(x)+","+Math.round(y);
  });

  console.log(max_v + " " +min_v + " " + path);

  RootPaper.setStart();
  RootPaper.path(path)
   .attr({stroke:ccolors[node_idx], 'stroke-width': 4})
   .glow({width: 3, color: ccolors[node_idx]});
  var c = RootPaper.setFinish();
  return c;
}


if (!Array.prototype.filter)
{
  Array.prototype.filter = function(fun /*, thisp*/)
  {
    var len = this.length;
    if (typeof fun != "function")
      throw new TypeError();

    var res = new Array();
    var thisp = arguments[1];
    for (var i = 0; i < len; i++)
    {
      if (i in this)
      {
        var val = this[i]; // in case fun mutates this
        if (fun.call(thisp, val, i, this))
          res.push(val);
      }
    }

    return res;
  };
}

if (!Array.prototype.map)
{
  Array.prototype.map = function(fun /*, thisp*/)
  {
    var len = this.length;
    if (typeof fun != "function")
      throw new TypeError();

    var res = new Array(len);
    var thisp = arguments[1];
    for (var i = 0; i < len; i++)
    {
      if (i in this)
        res[i] = fun.call(thisp, this[i], i, this);
    }

    return res;
  };
}
